﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace PStree
{
    public partial class Form1 : Form
    {
        protected const int     TEN = 6;                    //点の幅
        protected const int     LENGTH = 6;                //矢印の先の長さ
        protected const double  ANGLE  = 3.1415/180.0*30.0; //矢印の開く角度 … 現在30度
        protected static System.Drawing.Color BACKCOLOR = Color.FromArgb(255, 255, 192);
        protected static System.Drawing.SolidBrush RBRUSH = new SolidBrush(Color.Red);  //ブラシにRedを指定

        //不要 Graphics grfx;  // Graphics オブジェクト
        protected System.Drawing.Image image1;   //ImageObject ダブルバッファリング用

#if false
        int start = 0;  // 1 = 始点 確定
        int startX;     // Line X 始点
        int startY;     // Line Y 始点
        int endX;       // Line X 終点
        int endY;       // Line Y 終点
#endif
//        public const int MAX_POINTS = 200;    //表示最大個数
        
        //ノード情報
        protected class nod_inf {
            public int pn =-1;          //自ノード番号(通番では無い)
            public int px = 0, py = 0;  //節点のX,Y座標
            public int on = -1;         //親ノード番号(通番では無い)
            public int ok = -1;         //親ノードのk番目            
            public int ox = 0, oy = 0;  //親節点のX,Y座標
            public int edgeType = -1;   //o 親との枝のタイプ。-1:左 1:右 0:親無し
            public int koType = 0;      //o 子との枝のタイプ。0:子無し 1:左子のみ 2:右子のみ 3:左右子有り
            public int vVal = 0;       //o 垂直線のｘ座標
            public int hVal = 0;       //o 水平線のｙ座標
            public int lLim = 0;       //o 水平線の左端のｘ座標
            public int rLim = 0;       //o 水平線の右端のｘ座標
            
            //コンストラクタ
            public nod_inf() {  }
            public nod_inf(int k, int Ipn, int Ipx, int Ipy, int Ion, int Iox, int Ioy, int Iok, int IedgeType, int IkoType, int IvVal, int IhVal, int IlLim, int IrLim) {
                this.pn = Ipn;          //自ノード番号(通番では無い)
                this.px = Ipx;
                this.py = Ipy;  //節点のX,Y座標
                this.on = Ion;         //親ノード番号(通番では無い)
                this.ok = Iok;         //親ノードのk番目            
                this.ox = Iox;
                this.oy = Ioy;  //親節点のX,Y座標
                this.edgeType = IedgeType;   //o 親との枝のタイプ。-1:左 1:右 0:親無し
                this.koType = IkoType;      //o 子との枝のタイプ。0:子無し 1:左子のみ 2:右子のみ 3:左右子有り
                this.vVal = IvVal;       //o 垂直線のｘ座標
                this.hVal = IhVal;       //o 水平線のｙ座標
                this.lLim = IlLim;       //o 水平線の左端のｘ座標
                this.rLim = IrLim;       //o 水平線の右端のｘ座標
            }
        }
        //ノード配列 ArrayList Of nod_inf
        protected System.Collections.ArrayList arNod = new System.Collections.ArrayList();

        //ノード番号カウンタ
        protected int pcounter = 0;

        public Form1()
        {
            InitializeComponent();
            //DLL_init
            int rc = PsTreeDllOp.Linit( this );
            if (rc < 0)  Environment.Exit(0);  //' 有効期限を超えたら終了 2013.09.19 YS

            //DLL_clear
            rc = PsTreeDllOp.Lclear(this);
            if (rc < 0) return;

        }
        private void Form1_Load(object sender, EventArgs e)
        {
            // Graphics オブジェクトの取得
            //pictureBox1.Image = new Bitmap(Screen.PrimaryScreen.WorkingArea.Width,
            //                               Screen.PrimaryScreen.WorkingArea.Height);
            //grfx = Graphics.FromImage(pictureBox1.Image);
            this.image1 = new Bitmap(Screen.PrimaryScreen.WorkingArea.Width,
                                           Screen.PrimaryScreen.WorkingArea.Height);
            //不要　this.grfx = Graphics.FromImage(this.image1);
            //pictureBoxへ貼り付け
            this.pictureBox1.Image = this.image1;
            
            //ノード配列クリア
            this.arNod.Clear();
        }
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            //if (start == 0)
            //{
            //    start = 1;
            //    startX = e.X;
            //    startY = e.Y;
            //    SolidBrush newbrush = new SolidBrush(Color.Red);  //ブラシにRedを指定
            //    grfx.FillEllipse(newbrush, (float)startX-TEN/2, (float)startY-TEN/2, (float)TEN, (float)TEN);
               
            //}
            //else
            //{
            //    start = 0;
            //    //if (end == 0) return;
            //    //end = 0;
            //    endX = e.X;
            //    endY = e.Y;
            //    SolidBrush newbrush = new SolidBrush(Color.Blue);  //ブラシにRedを指定
            //    grfx.FillEllipse(newbrush, (float)endX-TEN/2, (float)endY-TEN/2, (float)TEN, (float)TEN);
            //}
            //pictureBox1.Refresh();

            int rc = 0;
            if( this.radInsert.Checked == true ) {
                //ノード配列に追加
                nod_inf wnod = new nod_inf();
                wnod.pn = ++this.pcounter;          //自ノード番号(通番では無い)
                wnod.px = e.X;  //節点のX,Y座標 
                wnod.py = e.Y;  //節点のX,Y座標
                //DLL_insert
                rc = PsTreeDllOp.Linsert( this, wnod.pn, wnod.px, wnod.py );
                if( rc < 0 ) return;
                
                //追加成功　ノード情報再取得
                rc = getArNod();
                if( rc < 0 ) return;
                
                //pictureBoxを再描画
                this.pictureBox1.Refresh();
            } else if( this.radDelete.Checked == true ) {
                //クリックノードを取得
                int sel = -1;
                double sellen = 0.0, len;
                for( int i=0 ; i<this.arNod.Count; i++ ) {
                    nod_inf wnod = (nod_inf)arNod[i];
                    if( wnod.px - 2*TEN <= e.X && e.X <= wnod.px + 2*TEN &&
                        wnod.py - 2*TEN <= e.Y && e.Y <= wnod.py + 2*TEN ) {
                        len = (e.X - wnod.px) * (e.X - wnod.px) + (e.Y - wnod.py) * (e.Y - wnod.py);
                        //DLL_deletion
                        //ノードの位置が近いと混同する場合があるため、候補が複数ある場合は、距離の最短なノードを選択する
                        if (sel < 0 || sellen > len) {
                            sel = i;
                            sellen = len;
                        }
                    }
                 }
                if (sel >= 0) { //削除ノードがみつかった。ノードを削除する
                    nod_inf wnod = (nod_inf)arNod[sel];
                    rc = PsTreeDllOp.Ldeletion(this, wnod.pn, wnod.px, wnod.py);
                    if (rc < 0) return;
                } else {         //削除ノードがみつからなかった。再描画せずに戻る
                    return;
                }
                //削除成功　ノード情報再取得
                rc = getArNod();
                if( rc < 0 ) return;

                //pictureBoxを再描画
                this.pictureBox1.Refresh();
            }
        }

        //ノード情報を取得する
        protected int getArNod() {
            int rc = 0;           
            int Inum = 0;
            int Ipn, Ipx, Ipy, Ion, Iox, Ioy, Iok, IedgeType, IkoType, IvVal, IhVal, IlLim, IrLim;
            
            //arNodのクリア
            this.arNod.Clear();

            unsafe {
                //DLL_getNodeNum
                rc = PsTreeDllOp.LgetNodeNum( this, &Inum);
            }
            if( rc != 0 ) goto quit;
//制限を除く KS140702
//            if( Inum > 200 ) {
//                System.Windows.Forms.MessageBox.Show(this, "number of points is over limit(" + MAX_POINTS + ")");
//                rc = -1;
//                goto quit;
//            }

            for( int i=0; i<Inum; i++ ) {
                unsafe {
                    //DLL_getNodeInf
                    rc = PsTreeDllOp.LgetNodeInf( this, i, &Ipn, &Ipx, &Ipy, &Ion, &Iox, &Ioy, &Iok, &IedgeType, &IkoType, &IvVal, &IhVal, &IlLim, &IrLim);
                }
                if( rc != 0 ) goto quit;
                nod_inf wnod = new nod_inf(i, Ipn, Ipx, Ipy, Ion, Iox, Ioy, Iok, IedgeType, IkoType, IvVal, IhVal, IlLim, IrLim);
                
                //arNodに追加
                this.arNod.Add( wnod );
            }
            quit:
                return rc;
        }
        //ノード情報から描画
        protected void drawArNod( Graphics g ) {

//            System.Diagnostics.Debug.Write("drawArNod:Count = " + this.arNod.Count + "\n");
            //境界線を引く
            if (this.chkBound.Checked == true) {
                for (int i = 0; i < this.arNod.Count; i++) {
                    nod_inf wnod = (nod_inf)arNod[i];
                    int lx = wnod.lLim;
                    int rx = wnod.rLim;
                    if (lx < 0) lx = 0;
                    if (rx > this.image1.Width) rx = image1.Width;
                    g.DrawLine(Pens.LightGray, lx, wnod.hVal, rx, wnod.hVal);  //水平
                    g.DrawLine(Pens.LightGray, wnod.vVal, wnod.hVal, wnod.vVal, 0);  //垂直
                }
            }

            //親子の線をひく
            if (this.chkTree.Checked == true) {
                for (int i = 0; i < this.arNod.Count; i++) {
                    nod_inf wnod = (nod_inf)arNod[i];
                    if( wnod.on >= 0 ) {
//                        System.Diagnostics.Debug.Write("px = " + wnod.px + " py = " + wnod.py + " ox = " + wnod.ox + " oy = " + wnod.oy + " edgeType = " + wnod.edgeType +"\n");
                        if (wnod.edgeType < 0)  //左
                            g.DrawLine(Pens.Blue, wnod.px, wnod.py, wnod.ox, wnod.oy);
                        else //右
                            g.DrawLine(Pens.Red, wnod.px, wnod.py, wnod.ox, wnod.oy);               
                    }
                }
            }

            //point描画
            for (int i = 0; i < this.arNod.Count; i++) {
                nod_inf wnod = (nod_inf)arNod[i];
//                System.Diagnostics.Debug.Write("px = " + wnod.px + " py = " + wnod.py + "\n");
                g.FillEllipse(RBRUSH, (float)wnod.px - TEN / 2, (float)wnod.py - TEN / 2, (float)TEN, (float)TEN);           
            }

        }

        //private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        //{
        //    /*start = 0;
        //    if (end == 0) return;
        //    end = 0;
        //    grfx.DrawLine(Pens.Red, startX, startY, endX, endY);
        //    pictureBox1.Refresh();
        //    */
        //}
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            //if (start == 0) return;
            //endX = e.X;
            //endY = e.Y;
            //pictureBox1.Refresh();  // マウスのドラッグ中の直線表示を要求
            
            //座標値をtextBoxに書く
            this.txtX.Text = (e.X).ToString();
            this.txtY.Text = (e.Y).ToString();
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            // マウスのドラッグ中の直線表示
            //if (end == 0) return;
            //e.Graphics.DrawLine(Pens.Red, startX, startY, endX, endY);
            
            //arNodの描画
            drawArNod( e.Graphics);
           
        }

        //private void CTbutton_Click(object sender, EventArgs e)
        //{
        //    grfx.DrawLine(Pens.Red, startX, startY, endX, endY);
        //    //grfx.DrawLine(Pens.Red, endX -5, endY, endX, endY + 5);
        //    //grfx.DrawLine(Pens.Red, endX -5, endY + 10, endX, endY + 5);

        //    double dbAng = 3.1415 + System.Math.Atan2(endY - startY, endX - startX);

        //    int nX, nY;
        //    for ( int i=-1; (i<=1); i+=2)
        //    {
        //        nX = (int)(System.Math.Cos(dbAng + ANGLE * i) * LENGTH) + endX;
        //        nY = (int)(System.Math.Sin(dbAng + ANGLE * i) * LENGTH) + endY;
        //        grfx.DrawLine(Pens.Red, nX, nY, endX, endY);
        //    }
        //    pictureBox1.Refresh();
        //}

        private void Clearbutton_Click(object sender, EventArgs e)
        {

            //DLL_clear
            int rc = PsTreeDllOp.Lclear( this );
            if( rc < 0 ) return;

            //arNodのクリア
            this.arNod.Clear();

            //背景のクリア
            //grfx.Clear(pictureBox1.BackColor);            
            pictureBox1.BackColor = BACKCOLOR;
            
            pictureBox1.Refresh();
           
            this.radInsert.Checked = true;
           
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            //DLL_Fil
            int rc = PsTreeDllOp.Lfin(this);

            //arNodのクリア
            if( this.arNod != null ) {
                this.arNod.Clear();
                this.arNod = null;
            }
            Application.Exit(); //'プログラム停止
        }

        private void btnSet_Click(object sender, EventArgs e)
        {
            if( this.radInsert.Checked == false ) return;
            //指定位置にポイントを描画
            String sx = txtX.Text;
            String sy = txtY.Text;
            try {
                int px = int.Parse( sx );
                int py = int.Parse( sy );
                if( px >= 0 && px < this.image1.Width && py >= 0 && py < this.image1.Height) {
                    //点を描画
                    //DLL_insert
                    int pn = ++this.pcounter;
                    int rc = PsTreeDllOp.Linsert(this, pn, px, py);
                    if( rc < 0 ) return;
                    //データ取得
                    rc = getArNod();
                    if( rc < 0 ) return;
                    
                    //再描画
                    this.pictureBox1.Refresh();
                    
                    //focusを移動
                    this.txtX.Focus();
                    this.txtX.SelectAll();
                }
            } catch( Exception ex ) {
                //何もしない
            }
        }

        private void chkBound_CheckedChanged(object sender, EventArgs e)
        {
            //再描画
            this.pictureBox1.Refresh();
        }

        private void chkTree_CheckedChanged(object sender, EventArgs e)
        {
            //再描画
            this.pictureBox1.Refresh();
        }

        private void txtY_Enter(object sender, EventArgs e) {
            this.txtY.SelectAll();
        }

        private void txtX_Enter(object sender, EventArgs e) {
            this.txtX.SelectAll();

        }

        private void txtY_MouseUp(object sender, MouseEventArgs e) {
            this.txtY.SelectAll();
        }

        private void txtX_MouseUp(object sender, MouseEventArgs e) {
            this.txtX.SelectAll();

        }

        private void txtX_KeyPress(object sender, KeyPressEventArgs e) {
            if (e.KeyChar == System.Convert.ToChar(System.Windows.Forms.Keys.Return)) {
                btnSet_Click(null, null);
            }
        }

        private void txtY_KeyPress(object sender, KeyPressEventArgs e) {
            if (e.KeyChar == System.Convert.ToChar(System.Windows.Forms.Keys.Return)) {
                btnSet_Click(null, null);
            }
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            int rc;

            if (textBox_file.Text.Length > 0) {
                openFileDialog1.FileName = textBox_file.Text;
            } else {  //ダイアログ表示
                if (openFileDialog1.ShowDialog() == DialogResult.Cancel) return;
            }
            //設定
            if (openFileDialog1.FileName.Length > 0) {
                textBox_file.Text = openFileDialog1.FileName;
            }
            PsTreeDllOp.LfilRead(this, textBox_file.Text);
            getArNod();
            this.pictureBox1.Refresh();
        }

        private void btnWrt_Click(object sender, EventArgs e)
        {
            int rc;

            if (textBox_file.Text.Length > 0) {
                saveFileDialog1.FileName = textBox_file.Text;
            } 
            //ダイアログ表示
            if (saveFileDialog1.ShowDialog() == DialogResult.Cancel) return;
            //設定
            if (saveFileDialog1.FileName.Length > 0) {
                textBox_file.Text = saveFileDialog1.FileName;
            }
            rc = PsTreeDllOp.LfilWrite(this, textBox_file.Text);
        }      
    }
}
