using System.Windows.Forms;
using System.Runtime.InteropServices;
using System;



namespace PStree
{
    static class PsTreeDllOp
    {
        //DLL関数定義
        [DllImport("PsTreeDll.dll")]
        private extern static int pstInit();

        [DllImport("PsTreeDll.dll")]
        private extern static int pstFin();

        [DllImport("PsTreeDll.dll")]
        private extern static int pstClear();

        [DllImport("PsTreeDll.dll")]
        private extern static int pstInsert(int pn, int px, int py);
        //insert  ノード追加
        //int rc >=0:正常 <0:メモリエラー
        // int pn,         //i 節点番号。任意の値
        // int px,         //i Ｘ座標の値
        // int py);        //i Ｙ座標の値

        [DllImport("PsTreeDll.dll")]
        private extern static int pstDeletion(int pn, int px, int py);
        //deletion ノード削除
        //int rc    // 0:未登録 1:削除した
        // int pn,         //i 節点番号。任意の値
        // int px,         //i Ｘ座標の値
        // int py);        //i Ｙ座標の値

        [DllImport("PsTreeDll.dll")]
        private unsafe extern static int pstGetNodeNum(int* Inum);
        //getNodeNum	(tree描画用)節点数を返す
        //int rc 0:正常
        //int *num                  //o 節点数。

        [DllImport("PsTreeDll.dll")]
        private unsafe extern static int pstGetNodeInf(int k, int* Ipn, int* Ipx, int* Ipy, int* Ion, int* Iox, int* Ioy,
            int* Iok, int* IedgeType, int* IkoType, int* IvVal, int* IhVal, int* IlLim, int* IrLim);
        //getNodeInf	(tree描画用)ｋ番目の節点の情報を返す
        //int rc 0:正常
        //int k,                     //i 0..cc_getNodeNum()で、節点の通番。
        //int *pn, int *px, int *py, //o ｋ番目の節点情報
        //int *on, int *ox, int *oy, //o 親節点の節点情報
        //int *ok,                   //o 親のｋ番号。-1:親無し
        //int *edgeType,             //o 親との枝のタイプ。-1:左 1:右 0:親無し
        //int *koType,               //o 子との枝のタイプ。0:子無し 1:左子のみ 2:右子のみ 3:左右子有り
        //int *vVal,                 //o 垂直線のｘ座標
        //int *hVal,                 //o 水平線のｙ座標
        //int *lLim,                 //o 水平線の左端のｘ座標
        //int *rLim)                 //o 水平線の右端のｘ座標

        [DllImport("PsTreeDll.dll")]
        private unsafe extern static int pstRead(char[] fname);

        [DllImport("PsTreeDll.dll")]
        private unsafe extern static int pstWrite(char[] fname);

        private const int DBG = 1;
        private const bool fdummy_old = false;
        private const bool fdummy = true;

        //Class共通変数
        private static System.Windows.Forms.Cursor oldc;       //保存カーソル
        public static String[] StrDlm = { "\t" };              //tab区切り

        //Class共通関数
        //Consoleに出力
        public static void System_print(String msg)
        {
            System.Diagnostics.Debug.Write(msg + "\r\n");
        }

        //エラーメッセージを出力
        //メッセージダイアログ表示１
        //private static void showMessageC(System.Windows.Forms.Form dia, int rc, String wtitle) {
        //    //300Lを呼ぶ
        //    ZIFW0300L.showMessageC(dia, rc, wtitle);
        //}
        //メッセージダイアログ表示２
        private static void showMessage2(System.Windows.Forms.Form dia, int rc, String s1, String s2)
        {
            System_print(s1);
            System.Windows.Forms.MessageBox.Show(s1, s2 + "エラー");
        }

        //initラッパー
        public static int Linit(System.Windows.Forms.Form dia)
        //[DllImport("PsTreeDll.dll")]
        //private extern static int init();
        {
            int rc = 0;
            String wtitle = "pstInit";
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                rc = 0;
            } else {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;

                rc = pstInit();

                dia.Cursor = oldc;

                if (rc != 0) {
                    //showMessage(dia, rc, wtitle);
                    //showMessage2(dia, rc, wtitle, "");
                    showMessage2(dia, rc, "使用有効期限を過ぎています", ""); // 2013.09.19 YS
                    if (rc > 0) rc = -999; // '091204
                }
            }
            return rc;
        }

        //finラッパー
        public static int Lfin(System.Windows.Forms.Form dia)
        //[DllImport("PsTreeDll.dll")]
        //private extern static int fin();
        {
            int rc = 0;
            String wtitle = "pstFin";
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                rc = 0;
            } else {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;

                rc = pstFin( );

                dia.Cursor = oldc;

                if (rc != 0) {
                    showMessage2(dia, rc, wtitle, "");
                    if (rc > 0) rc = -999; // '091204
                }
            }
            return rc;
        }

        //clearラッパー
        public static int Lclear(System.Windows.Forms.Form dia)
        //[DllImport("PsTreeDll.dll")]
        //private extern static int clear();
        {
            int rc = 0;
            String wtitle = "pstClear";
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                rc = 0;
            } else {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;

                rc = pstClear();

                dia.Cursor = oldc;

                if (rc < 0) {
                    showMessage2(dia, rc, wtitle, "");
                }
            }
            return rc;
        }

        //insertラッパー
        public static int Linsert( System.Windows.Forms.Form dia, int pn, int px, int py ) 
        //[DllImport("PsTreeDll.dll")]
        //private extern static int insert(int pn, int px, int py);
        //insert  ノード追加
        //int rc >=0:正常 <0:メモリエラー
        // int pn,         //i 節点番号。任意の値
        // int px,         //i Ｘ座標の値
        // int py);        //i Ｙ座標の値
        {
            int rc = 0;
            String wtitle = "pstInsert";
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                rc = 0;
            } else {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;

                rc = pstInsert(pn, px, py);

                dia.Cursor = oldc;

                if (rc < 0) {
                    showMessage2(dia, rc, wtitle, "");
                }
            }
            return rc;
        }

        //deletionラッパー
        public static int Ldeletion( System.Windows.Forms.Form dia, int pn, int px, int py ) 
        //[DllImport("PsTreeDll.dll")]
        //private extern static int deletion(int pn, int px, int py);
        //deletion ノード削除
        //int rc    // 0:未登録 1:削除した
        // int pn,         //i 節点番号。任意の値
        // int px,         //i Ｘ座標の値
        // int py);        //i Ｙ座標の値
        {
            int rc = 0;
            String wtitle = "pstDeletion";
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                rc = 0;
            } else {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;

                rc = pstDeletion(pn, px, py);

                dia.Cursor = oldc;

                if (rc < 0) {  //-でエラー
                    showMessage2(dia, rc, wtitle, "");
                }
            }
            return rc;
        }

        //getNodeNumラッパー
        public unsafe static int LgetNodeNum(System.Windows.Forms.Form dia, int *Inum)
        //[DllImport("PsTreeDll.dll")]
        //private unsafe extern static int getNodeNum(int* Inum);
        //private unsafe extern static int getNodeNum(int* Inum);
        //getNodeNum	(tree描画用)節点数を返す
        //int rc 0:正常
        //int *num                  //o 節点数。
        {
            int rc = 0;
            String wtitle = "pstGetNodeNum";
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                unsafe {
                    *Inum = 0;
                }
                rc = 0;
            } else {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;

                rc = pstGetNodeNum(Inum);

                dia.Cursor = oldc;

                if (rc != 0) {
                    showMessage2(dia, rc, wtitle, "");
                }
            }
            return rc;
        }

        //getNodeInfラッパー
        public unsafe static int LgetNodeInf(System.Windows.Forms.Form dia, int k, int* Ipn, int* Ipx, int* Ipy, int* Ion, int* Iox, int* Ioy,
            int* Iok, int* IedgeType, int* IkoType, int* IvVal, int* IhVal, int* IlLim, int* IrLim)
        //[DllImport("PsTreeDll.dll")]
        //private unsafe extern static int getNodeInf(int k, int* Ipn, int* Ipx, int* Ipy, int* Ion, int* Iox, int* Ioy,
        //    int* Iok, int* IedgeType, int* IoType, int* IvVal, int* IhVal, int* IlLim, int* IrLim);
        //getNodeInf	(tree描画用)ｋ番目の節点の情報を返す
        //int rc 0:正常
        //int k,                     //i 0..cc_getNodeNum()で、節点の通番。
        //int *pn, int *px, int *py, //o ｋ番目の節点情報
        //int *on, int *ox, int *oy, //o 親節点の節点情報
        //int *ok,                   //o 親のｋ番号。-1:親無し
        //int *edgeType,             //o 親との枝のタイプ。-1:左 1:右 0:親無し
        //int *koType,               //o 子との枝のタイプ。0:子無し 1:左子のみ 2:右子のみ 3:左右子有り
        //int *vVal,                 //o 垂直線のｘ座標
        //int *hVal,                 //o 水平線のｙ座標
        //int *lLim,                 //o 水平線の左端のｘ座標
        //int *rLim)                 //o 水平線の右端のｘ座標
        {
            int rc = 0;
            String wtitle = "pstGetNodeInf";
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                unsafe {
                    *Ipn = 0; *Ipx = 0; *Ipy = 0; //o ｋ番目の節点情報
                    *Ion = 1; *Iox = 10; *Ioy = 10; //o 親節点の節点情報
                    *Iok = 1;                    //o 親のｋ番号。-1:親無し
                    *IedgeType = -1;             //o 親との枝のタイプ。-1:左 1:右 0:親無し
                    *IkoType = 2;                //o 子との枝のタイプ。0:子無し 1:左子のみ 2:右子のみ 3:左右子有り
                    *IvVal = 10;                 //o 垂直線のｘ座標
                    *IhVal = 10;                 //o 水平線のｙ座標
                    *IlLim = 0;                  //o 水平線の左端のｘ座標
                    *IrLim = 30;                 //o 水平線の右端のｘ座標
                }
                rc = 0;
            } else {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;

                rc = pstGetNodeInf( k, Ipn, Ipx, Ipy, Ion, Iox, Ioy,
                    Iok, IedgeType, IkoType, IvVal, IhVal, IlLim, IrLim);

                dia.Cursor = oldc;

                if (rc != 0) {
                    showMessage2(dia, rc, wtitle, "");
                }
            }
            return rc;
        }

        public static int LfilRead(   //KS110330ADD 
             System.Windows.Forms.Form dia,
           String fname)    //i ファイルパス
        {
            int rc = 0;
            String wtitle = "read";
            char[] chr = new char[1024 + 1];
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                rc = 0;
            }  else {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;

                // String→charへ変換
                //strcpy(chr, path.c_str());
                if (fname != "") rc = pstRead(fname.ToCharArray());
                dia.Cursor = oldc;
                if (rc < 0) {
                    showMessage2(dia, rc, "ファイル入力に失敗しました。", wtitle);
                }
            }
            return rc;
        }
        public static int LfilWrite(   //KS110330ADD 
            System.Windows.Forms.Form dia,
            String fname)    //i ファイルパス
        {
            int rc = 0;
            String wtitle = "write";
            char[] chr = new char[1024 + 1];
            if (DBG > 0) System_print(wtitle);

            if (fdummy_old) {
                rc = 0;
            }  else  {
                oldc = dia.Cursor;
                dia.Cursor = System.Windows.Forms.Cursors.WaitCursor;
                // String→charへ変換
                //strcpy(chr, path.c_str());
                if (fname != "") rc = pstWrite(fname.ToCharArray());
                dia.Cursor = oldc;
                if (rc < 0) {
                    showMessage2(dia, rc, "ファイル出力に失敗しました。", wtitle);
                }
            }
            return rc;
        }
    }
}
