/*
 * FILE     : McCreght2.cpp
 * Copyright (C) 2007 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : q[vT(McCreight)(balanced priority search trees)
	          l̕tT؁Al̃q[v
 * AUTHER   : N.Tsuchiya  2007.11.25
 */
/*
	2011/04/04 heapTypeǉB 0:傫D 1:D
	http://www.cs.duke.edu/courses/fall08/cps234/handouts/SMJ000257.pdf
	E.M.McCreight. Priority search trees. SIAM Journal on Computing, 14(2):257.276, May 1985.
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h> //http://www.jaist.ac.jp/~t-asano/dstruct/kousei.txt

#define MIN(x,y) ((x) < (y) ? (x) : (y))
#define     E 0          /* oXx E: EB*/
#define     L -1         /* oXx L: ɌXĂB*/
#define     R 1          /* oXx R: EɌXĂB*/
#define isEmpty(p) ((p)<=Empty)

#define PSTree_Main
#include "McCreight2.h" // McCreght (Place Holderŋp)
#include "xqsort.h"

static int unbalance = 0;  //eXgpB1:oXȂ

/*	ID_PSTree::firstPair	LȑSyA̍ŏ̂PԂ
/*******************************************************************/
int PSTree::firstPair(int *inf) //>=0:ߓ_ԍ([Uw) -1:I
{
	int kol;
	*inf = root;
	for( kol = nodes.a.v[*inf].left; ; kol = nodes.a.v[kol].left ) {		CHKA(0, kol, nodes.a.size());
		if( isEmpty(nodes.a.v[kol].q) ) break;
		*inf = kol;
	}
	return (isEmpty(*inf) || isEmpty(nodes.a.v[*inf].q)) ? -1 : this->pairs.a.v[nodes.a.v[*inf].q].n;
}
/*	ID_PSTree::nextPair	LȑSyA̎̂PԂ
/*******************************************************************/
int PSTree::nextPair(int *inf) //>=0:ߓ_ԍ([Uw) -1:I
{
	int kol, n;

	//ɕԂ͉̂Eq̍ōq
	n = *inf;
	for( kol = nodes.a.v[*inf].right; kol > 0; kol = nodes.a.v[kol].left ) {
		if( isEmpty(nodes.a.v[kol].q) ) break;
		*inf = kol;
	}
	//Eqΐeǂčŏ̉Ee
	if( n == *inf ) {
		kol = *inf;												CHKA(1, kol, nodes.a.size());
		for( *inf = nodes.a.v[*inf].oya; *inf > 0; *inf = nodes.a.v[*inf].oya ) {
			if( nodes.a.v[*inf].left == kol ) break;
			kol = *inf;
	}
	}
	return (isEmpty(*inf) || isEmpty(nodes.a.v[*inf].q)) ? -1 : this->pairs.a.v[nodes.a.v[*inf].q].n;
}
/*	ID_PSTree::findBelow	m[h̉T(܂)
/*******************************************************************/
int PSTree::findBelow(  //anodeȉłłm[hԂ
	int anode )
{
	int rc = Empty, yflg;            CHKA(0, anode, nodes.a.size());
	BPSTnode *t = &nodes.a.v[anode];    CHKA(0, t->q, pairs.a.size()); CHKA(0, t->p, pairs.a.size());
	BPSTpair *q;
	if( isEmpty(anode) ) goto                                           quit;
	if( t->validP  /*&& yflg == 0*/ ) {
		yflg = ( compHeap(pairs.a.v[t->p].y, y0) > 0 ) ;
		q = &pairs.a.v[t->q];
		if( yflg == 0 ) {
			//T
			if( q->x >= x1 && ! isEmpty(t->left)  /*&& yflg == 0*/ )
				if( (rc = findBelow(t->left)) != Empty ) goto           quit;
			//m[h`FbN
			BPSTpair *p = &pairs.a.v[t->p];
			if( p->x >= x1 && p->x <= x2 /*&& yflg == 0*/ ) {
				lastIsP = 1;
				rc = anode;
				goto                                                    quit;
			}
		}
		if( ! t->duplQ ) {
			if( q->x >= x1 && q->x <= x2 && compHeap(q->y, y0) <= 0 ) {
				lastIsP = 0;
				rc = anode;
				goto                                                    quit;
			}
		}
		//ET
		if( yflg == 0 && q->x <= x2 && ! isEmpty(t->right) )
			rc = findBelow(t->right);
	} else if( ! t->duplQ ) {
		q = &pairs.a.v[t->q];
		if( q->x >= x1 && q->x <= x2 && compHeap(q->y, y0) <= 0 ) {
			lastIsP = 0;
			rc = anode;
			goto                                                        quit;
		}
	}
quit:
	return rc;
}
/*	ID_PSTree::ReportInPSTree	
/*******************************************************************/
int PSTree::ReportInPSTree(int v, int y0,
	VECTOR<int>& ans, VECTOR<int>& stack)
//́Fq[vT؂̐ߓ_n Ǝ[y0:]
//óFy[y0:]ɗLT ׂ̂Ă̓_B
{
	int rc, n_stack; //profilełQQ
	BPSTnode *vn;
	if( v > 0 ) {
		n_stack  = 0;
		vn = &nodes.a[v];
		for( ; ; ) {
			//v.q񍐂ׂǂׂ(yl̂ݒׂ)
			if( ! vn->duplQ ) {         //CHKA(1, vn->q, pairs.a.size());
				if( compHeap(pairs.a.v[vn->q].y, y0) <= 0 ) {
//				if( QSORT_COMP(y0, pairs.a.v[vn->q].y) <= 0 ) { //p
					ans.push_back( vn->q );
				}
			}
			if( vn->validP ) {          //CHKA(1, vn->p, pairs.a.size()); //v.validP then
				if( compHeap(pairs.a.v[vn->p].y, y0) <= 0 ) { //v.p.yq[v𖞂
//				if( QSORT_COMP(y0, pairs.a.v[vn->p].y) <= 0 ) { //v.p.yq[v𖞂 //p
					//v.p񍐂(ׂ͕sv)
					ans.push_back( vn->p );
					if( vn->left ) {            // v.left nullłȂ
						if( vn->right ) {       // v.right nullłȂ
							stack[n_stack++] = vn->right; //v.rightvbV_EB
						}
						vn = &nodes.a[vn->left];
						continue;
					} else if( vn->right  ) {      //v.right nullłȂ
						vn = &nodes.a[vn->right];
						continue;
					}
				}
			}
			//v.pAv.p.yq[v𖞂ȂB܂́AE̎qߓ_
			if( n_stack-- <= 0 ) break;
			vn = &nodes.a[stack[n_stack]];
		}   //end while
	}
	rc = 0;
	return rc;
}
/*  ID_PSTree::side3Query	R[x1:x2]~[y0:]ɗLT ׂ̂Ă̓_̃Xgans[]B
***************************************************************************/
int PSTree::side3Query( // >=0:𓚐 <0:G[
	int px1, int px2, int py0,
	VECTOR<int>& ans, VECTOR<int>& stack)
//́Fq[vTT ƂR[x1:x2]~[y0:]
//óFR[x1:x2]~[y0:]ɗLT ׂ̂Ă̓_̃Xgans[]B
{
	int		rc = 0, v, p, q, vsplit, vv, aans, apair;

	if( stack.resize(nodes.a.size()) < 0 ) { rc = -1; goto                     quit; }
	ans.clear();
//	ans.push_back(0);
	//SplitNodeTB
	vv = 0;
	v = root; //v  T.root
	x1 = px1; x2 = px2; y0 = py0;
	while( v != 0 ) {                //v nullłȂ do
		vv = v;
		if( nodes.a[v].validP ) {
			p = nodes.a[v].p;					CHKA(0, p, pairs.a.size());
			if( compHeap(pairs.a.v[p].y, py0) <= 0 ){ // v.p.yq[v𖞂
				//v.p񍐂ׂǂׂ(xl̂ݒׂ)
				if( px1 <= pairs.a.v[p].x && pairs.a.v[p].x <= px2 ) {
					ans.push_back( p );
				}
				q = nodes.a[v].q;					CHKA(1, q, pairs.a.size());
				if( pairs.a.v[q].x < px1 ) {            //v.q.x < x1 then
					v = nodes.a[v].right;       //v  v.right
				} else if( pairs.a.v[q].x > px2 ) {     // v.q.x > x2 then
					v = nodes.a[v].left;        //v  v.left
				} else break;                //SplitNode𔭌̂Ń[vI
				continue;
			}
		}
		//validPfalseA܂́Av.p.yq[v𖞂ȂȂ炻̉͌Ȃ
		v  = 0;  //v  null
	}
	//vv.q񍐂ׂǂׂ(x,ylɒׂ)
	if( vv > 0 ) {
		q = nodes.a[vv].q;
		if( ! nodes.a[vv].duplQ && px1 <= pairs.a.v[q].x && pairs.a.v[q].x <= px2 && compHeap(pairs.a.v[q].y, py0) <= 0 ) {
			ans.push_back( q );
		}
	}
	vsplit = v;          //vsplit  v 
	if( vsplit == 0 ) {      //vsplitnull then Ȃ
	} else {
		// x1ւ̌oHɉCoH̐ߓ_Ƃ̉E̕؂̃f[^
		v = nodes.a[vsplit].left;            //v  vsplit.left
		while( v != 0 ) {                 //v nullłȂ do
			q = nodes.a[v].q;					CHKA(1, q, pairs.a.size());
			//v.q񍐂ׂǂׂ(v.q.x <= x2͏ɐ)
			if( ! nodes.a[v].duplQ && pairs.a.v[q].x >= px1 && compHeap(pairs.a.v[q].y, py0) <= 0 ) {
				ans.push_back( q );
			}
			if( nodes.a[v].validP ) {         //v.validP then
				p = nodes.a[v].p;					CHKA(0, p, pairs.a.size());
				if( compHeap(pairs.a.v[p].y, py0) <= 0 ){ // v.p.yq[v𖞂
					//v.p񍐂ׂǂׂ(xl̂ݒׂ)
					if( px1 <= pairs.a.v[p].x /*&& pairs.a.v[p].x <= px2*/ ) { CHKB(pairs.a.v[p].x, px2, px2);
						ans.push_back( p );
					}
					if( pairs.a.v[q].x >= px1 ) {     // v.q.x >= x1 then
						ReportInPSTree(nodes.a[v].right, y0, ans, stack);
						v = nodes.a[v].left;        //v  v.left
					} else {
						v = nodes.a[v].right;       //v  v.right
					}
					continue;
				}
			}
			//validPfalseA܂́Av.p.yq[v𖞂ȂȂ炻̉͌Ȃ
			v = 0;              //v  null
		}//end while
		// x2 ւ̌oHɉC̍̕؂̃f[^
		v = nodes.a[vsplit].right;             //v  vsplit.right
		while( v != 0 ) {                   // v nullłȂ do
			q = nodes.a[v].q;					CHKA(1, q, pairs.a.size());
			//v.q񍐂ׂǂׂ(v.q.x >= x1͏ɐ)
			if( ! nodes.a[v].duplQ && pairs.a.v[q].x <= px2 && compHeap(pairs.a.v[q].y, py0) <= 0 ) {
				ans.push_back( q );
			}
			if( nodes.a[v].validP ) {          // v.validP then
				p = nodes.a[v].p;					CHKA(1, p, pairs.a.size());
				if( compHeap(pairs.a.v[p].y, py0) <= 0 ){  //v.p.yq[v𖞂
					//v.p񍐂ׂǂׂ(xl̂ݒׂ)
					if( /*px1 <= pairs.a.v[p].x &&*/ pairs.a.v[p].x <= px2 ) { CHKB(pairs.a.v[p].x, px2, px2);
						ans.push_back( p );
					}
					if( pairs.a.v[q].x <= px2 ) {       //v.q.x <= x2 then
						ReportInPSTree(nodes.a[v].left, y0, ans, stack);
						v = nodes.a[v].right;     //v  v.right
					} else {
						v = nodes.a[v].left;      //v  v.left
					}
					continue;
				}
			}
			//validPfalseȂA܂́Av.p.yq[v𖞂Ȃ̉͌Ȃ
			v = 0;                  //v  null
		}                               //end while
	}
	if(dbgf[8]) {
		for( q = 0; q < ans.size(); ++q ) {
			p = ans[q];                    CHKA(0, p, pairs.a.size());
			if( px1 <= pairs.a.v[p].x && pairs.a.v[p].x <= px2 && compHeap(pairs.a.v[p].y, py0) <= 0 ) {
			}else {
				CHKB(px1, pairs.a.v[p].x, px2); CHKB(py0, py0, pairs.a.v[p].y); }
		}
		for( q=0, p = first(px1, px2, py0); p >= 0; p = next(), ++q ) ; //Dprintf(" %2d", p);
		              CHKB(q, ans.size(), q);
	}
	for( aans = 0; aans < ans.size(); ++aans ) {
		apair = ans[aans];
		ans[aans] = pairs.a.v[apair].n;
	}
	rc = ans.size();
quit:
	return rc;
}
/*	ID_PSTree::firstAns	x1xx2yy0łŏ̃m[h̐ߓ_ԍ([Uw)Ԃ
/*******************************************************************/
int PSTree::firstAns(  //ߓ_ԍ([Uw)B-1:Yߓ_, <-1:G[
	int *inf,                    //o 
	int px1, int px2, int py0)   //T x1xx2yy0łm[h */
{
//ans[]SĒׂ
#if 0
	int rc, qq;

//	x1 = px1; x2 = px2; y0 = py0;
	if( (rc = side3Query(px1, px2, py0, ans, stack)) < 0 ) { rc = -99; goto    quit; }
	*inf = 0;
	qq = (0 < ans.size()) ? ans[0] : 0;                    CHKA(0, qq, pairs.a.size());
	rc = (qq > 0) ? pairs.a.v[qq].n : -1;
quit:
	return rc;
#else
	int 	anode = root, qq;
	x1 = px1; x2 = px2; y0 = py0;
	lastIsP = 0;
	if( isEmpty(anode) ) last_node = Empty;
	else                 last_node = findBelow(anode);
	*inf = last_node;
	if( lastIsP ) qq = nodes.a.v[last_node].p;
	else          qq = nodes.a.v[last_node].q;
	             						CHKA(0, qq, pairs.a.size());
	return (qq > 0) ? pairs.a.v[qq].n : -1;
#endif
}
/*	ID_PSTree::nextAns	x1xx2yy0ł鎟̃m[h̐ߓ_ԍ([Uw)Ԃ
/*******************************************************************/
int PSTree::nextAns(  //ߓ_ԍ([Uw)B-1:Yߓ_
	int *inf)                    //io 
//	int px1, int px2, int py0)   //T x1xx2yy0łm[h NT120423add
{
#if 0
	int		qq; //profilełPR
	++(*inf);
	qq = (*inf < ans.size()) ? ans[*inf] : 0;
	return (qq > 0) ? pairs.a.v[qq].n : -1;
#else
	int 	anode, rt, qq;
	BPSTnode *t;

	last_node = *inf;
	anode = last_node;
	last_node = Empty;
	t = &nodes.a.v[anode];
	if( lastIsP ) {
		lastIsP = 0;
		if( ! t->duplQ && ! isEmpty(anode) ) {
			BPSTpair &q = pairs.a.v[t->q];
			if( q.x >= x1 && q.x <= x2 && compHeap(q.y, y0) <= 0 ) {  //compHeap : p - q
				last_node = anode;
				goto                                                    quit;
			}
		}
	}
	while( ! isEmpty(anode) /*&& isEmpty(last_node)*/ ) {
		//Em[hrootƂčōm[h
		if( t->validP && ! isEmpty(t->right) && pairs.a.v[t->q].x <= x2 && compHeap(pairs.a.v[t->p].y, y0) <= 0 )
			if( (last_node = findBelow( t->right)) != Empty ) break;
		//ŏ̉E̐eBΊ
		for( rt = anode; ! isEmpty(rt); rt = anode ) {
			anode = nodes.a.v[rt].oya;
			if( rt == nodes.a.v[anode].right ) continue;
			break;
		}  CHKB(0, anode, anode);
		if( anode == Empty ) break;
		t = &nodes.a.v[anode];
		//m[h`FbN
		if( t->validP ) {
			BPSTpair &pp = pairs.a.v[t->p];
			if( pp.x >= x1 && pp.x <= x2 /*&& pp.y <= y0*/ ) {
				lastIsP = 1;
				last_node = anode;
				break;
			}
		}
		if( ! t->duplQ ) {
			BPSTpair &pq = pairs.a.v[t->q];
			if( /*pq.x >= x1 &&*/ pq.x <= x2 && compHeap(pq.y, y0) <= 0 ) {
				last_node = anode;
				break;
			}
		}
	}
quit:
	*inf = last_node;
	if( lastIsP ) qq = nodes.a.v[last_node].p;
	else          qq = nodes.a.v[last_node].q;
	return (qq > 0) ? pairs.a.v[qq].n : -1;
#endif
}
/*	ID_PSTree::first	Rx1xx2yy0łŏ̃m[h̐ߓ_ԍ([Uw)Ԃ
/*******************************************************************/
int PSTree::first(  //ߓ_ԍ([Uw)B-1:Yߓ_
	int px1, int px2, int py0)   //i T x1xx2yy0łm[h */
{
	int rc;
	if( root > 0 ) {
		x1 = px1; x2 = px2; y0 = py0;
		nextInf.clear();
		nextInf.push_back(NextInf(0,0));    //X^bN{g쐬
		nextInf.push_back(NextInf(root,0)); //TJnm[h
		rc = next();
	} else rc = -1;
	return rc;
}
/*	ID_PSTree::next	Rx1xx2yy0ł鎟̃m[h̐ߓ_ԍ([Uw)Ԃ
/*******************************************************************/
int PSTree::next()   //ߓ_ԍ([Uw)B-1:Yߓ_
{
	int rc, pyOk;
	BPSTnode *t;
	NextInf *topOfStack = &nextInf.v[nextInf.size() - 1];

	while( topOfStack->node > 0 ) {
		t = &nodes.a[topOfStack->node];
		pyOk = (t->validP && compHeap(pairs.a.v[t->p].y, y0) <= 0); //Land p.ynj
		switch( topOfStack->stat ) { //0:} 1: 2: 3:E} 4:
		case 0: //0:} Land p.ynjand x1q.x and leftL
			if( pyOk && t->left > 0 && x1 <= pairs.a.v[t->q].x ) {
				topOfStack->stat = 1;
				do {
					nextInf.push_back(NextInf(t->left, 1));
					t = &nodes.a[t->left];
					pyOk = (t->validP && compHeap(pairs.a.v[t->p].y, y0) <= 0); //Land p.ynj
				} while( pyOk && x1 <= pairs.a.v[t->q].x && t->left > 0 );
				topOfStack = &nextInf.v[nextInf.size() - 1];
			}
		case 1: //1: Land p.ynjand x1p.xx2
			if( pyOk && x1 <= pairs.a.v[t->p].x && pairs.a.v[t->p].x <= x2 ) {
				topOfStack->stat = 2;
				rc = pairs.a.v[t->p].n;
				goto                                                    quit;
			}
		case 2: //2: Land q.ynjand x1q.xx2
			if( ! t->duplQ && x1 <= pairs.a.v[t->q].x && pairs.a.v[t->q].x <= x2 && compHeap(pairs.a.v[t->q].y, y0) <= 0 ) {
				topOfStack->stat = 3;
				rc = pairs.a.v[t->q].n;
				goto                                                    quit;
			}
		case 3: //3:E} Land p.ynjand q.xx2 and rightL
			if( pyOk && t->right > 0 && pairs.a.v[t->q].x <= x2 ) {
				*topOfStack = NextInf(t->right, 0);
			} else {
				nextInf.pop_back();
				topOfStack -= 1;			}
		}
	}
	rc = -1;
quit:
	return rc;
}

/*  ID_PSTree::disposeP	t.ppushāAq[vm[hɂ
***************************************************************************/
int PSTree::disposeP( int anode )
{
	int rc;
	BPSTnode	*t;                               CHKA(1, anode, nodes.a.size());
	t = &nodes.a.v[anode];
	if( t->validP ) {
		rc = compX(&pairs.a.v[t->p], &pairs.a.v[t->q]);
		if( rc == 0 )                             CHKA(t->p, t->q, -571);
		if( rc <= 0 ) { CHKA(1, t->left, nodes.a.size()); //t.p̎qpush
			if( t->p == nodes.a.v[t->left].q ) {     //t.p.qƈv
				nodes.a.v[t->left].duplQ = false;    //  .duplQ.F. (.p͋̏ꍇłȂꍇ)
			} else {                              //t.p.qƕsvȂ(܂߂)
				disposeP( t->left );              //  t.left.ppushāAɂ
				nodes.a.v[t->left].p = t->p;         //  t.left.pt.p
				nodes.a.v[t->left].validP = true;    //  t.left.validP.T. (t.left.pLɂ)
			}                                     //
		} else {                                    CHKA(1, t->right, nodes.a.size());
			if( t->p == nodes.a.v[t->right].q ) {
				nodes.a.v[t->right].duplQ = false;
			} else {  
				disposeP( t->right );
				nodes.a.v[t->right].p = t->p;
				nodes.a.v[t->right].validP = true;
			}
		}
		t->validP = false;
	}
	return 0;
}
/*  ID_PSTree::extractP	t.ppopāAq[v̋𖄂߂B óFt.p t.validP t.left.duplQ t.right.duplQ
***************************************************************************/
int PSTree::extractP( int anode )
{
	                    CHKA(0, anode, nodes.a.size());
	BPSTnode	&t = nodes.a.v[anode], *lt, *rt;
	int		leftY, rightY, lstat, rstat; /*Worst = 999999999,*/

	lstat = rstat = 0;
	if( ! isEmpty(t.left) ) {    //q̃q[vl擾
		lt = &nodes.a.v[t.left];
		if( lt->validP ) {
			lstat = 1;
			leftY = pairs.a.v[lt->p].y;
		}
		if( ! lt->duplQ ) {
			if( lstat == 0 || compHeap(leftY, pairs.a.v[lt->q].y) > 0 ) {
				lstat = 2;
				leftY = pairs.a.v[lt->q].y;
			}
		}
	}
	if( ! isEmpty(t.right) ) {    //Eq̃q[vl擾
		rt = &nodes.a.v[t.right];
		if( rt->validP ) {
			rstat = 1;
			rightY = pairs.a.v[rt->p].y;
		}
		if( ! rt->duplQ ) {
			if( rstat == 0 || compHeap(rightY, pairs.a.v[rt->q].y) > 0 ) {
				rstat = 2;
				rightY = pairs.a.v[rt->q].y;
			}
		}
	}
	if( lstat == 0 && rstat == 0 ) {  //Ẽm[hǂ
		t.validP = false;
	} else if( lstat > 0 && (rstat == 0 || compHeap(leftY, rightY) < 0) ) {  //D
		if( lstat == 1 ) {
			t.p = lt->p;  //node[t.left].validP extractP()Őݒ肷̂ŕsv
			extractP( t.left );
		} else if( lstat == 2 ) {
			t.p = lt->q;                CHKB(false, lt->duplQ, false);
			lt->duplQ = true;
		}
		t.validP = true;
	} else if( rstat > 0 && (lstat == 0 || compHeap(leftY, rightY) >= 0) ) {  //ED
		if( rstat == 1 ) {
			t.p = rt->p;
			extractP( t.right );
		} else if( rstat == 2 ) {
			t.p = rt->q;                CHKB(false, rt->duplQ, false);
			rt->duplQ = true;
		}
		t.validP = true;
	} else {  CHKA(0, 0, -1);
		t.validP = false;
	}	
	return 0;
}
/*  ID_PSTree::rotateRight	
***************************************************************************/
int PSTree::rotateRight(
	int *anode,         // io
	int *phi )          //  o ]*anode̍
{
	int		c, e, q, r, s, he, hc, hq, hr, hs;
	e = *anode;                              CHKA(1, e, nodes.a.size());
	disposeP( e );
	c = nodes.a.v[e].left;                      CHKA(1, c, nodes.a.size());
	s = nodes.a.v[e].right;                     CHKA(0, s, nodes.a.size());
	q = nodes.a.v[c].left;                      CHKA(0, q, nodes.a.size());
	r = nodes.a.v[c].right;                     CHKA(0, r, nodes.a.size());
	disposeP( c );
	nodes.a.v[c].oya   = nodes.a.v[*anode].oya;
	*anode = c;
	if( ! isEmpty(r) ) nodes.a.v[r].oya   = e;
	else
		r = r;  //ɂ͗Ȃ
	nodes.a.v[e].left  = r;
	extractP( e );
	nodes.a.v[e].oya   = c;
	nodes.a.v[c].right = e;
	extractP( c );
	hq = nodes.a.v[q].hight;
	hr = nodes.a.v[r].hight;
	hs = nodes.a.v[s].hight;
	he = 1 + ((hr > hs) ? hr : hs);
	hc = 1 + ((hq > he) ? hq : he);
	nodes.a.v[e].hight = he;
	nodes.a.v[c].hight = hc;
	//adjustBalanceForRotateRight(c)
	*phi = hc;
	return 0;
}
/*  ID_PSTree::rotateLeft	
***************************************************************************/
int PSTree::rotateLeft(
	int *anode,         // io
	int *phi )          //  o ]*anode̍
{
	int		c, e, q, r, s, he, hc, hq, hr, hs;
	e = *anode;                            CHKA(1, e, nodes.a.size());
	disposeP( e );
	c = nodes.a.v[e].right;                   CHKA(1, c, nodes.a.size());
	s = nodes.a.v[e].left ;                   CHKA(0, s, nodes.a.size());
	q = nodes.a.v[c].right;                   CHKA(0, q, nodes.a.size());
	r = nodes.a.v[c].left ;                   CHKA(0, r, nodes.a.size());
	disposeP( c );
	nodes.a.v[c].oya   = nodes.a.v[*anode].oya;
	*anode = c;
	if( ! isEmpty(r) ) nodes.a.v[r].oya   = e;
	else
		r = r;  //ɂ͗Ȃ  NT111221 
	nodes.a.v[e].right = r;
	extractP( e );
	nodes.a.v[c].left  = e;
	nodes.a.v[e].oya   = c;
	extractP( c );
	hq = nodes.a.v[q].hight;
	hr = nodes.a.v[r].hight;
	hs = nodes.a.v[s].hight;
	he = 1 + ((hr > hs) ? hr : hs);
	hc = 1 + ((hq > he) ? hq : he);
	nodes.a.v[e].hight = he;
	nodes.a.v[c].hight = hc;
	//adjustBalanceForRotateRight(c)
	*phi = hc;
	return 0;
}
/*  ID_PSTree::adjustBalance	k/q]ŃoX߂
***************************************************************************/
int PSTree::adjustBalance(
	int *anode,            // io
	int *phi)              //  o
{
	BPSTnode	*t;
	int bc1, bc2, hL, hR;
	if( ! isEmpty(*anode) ) {           CHKA(1, *anode, nodes.a.size());
		bc1 = judgeBalance(*anode);
		t = &nodes.a.v[*anode];
		if( unbalance != 0 || bc1 > -2 && bc1 < 2) {
			hL = nodes.a.v[t->left ].hight;
			hR = nodes.a.v[t->right].hight;
			*phi = 1 + ((hL > hR) ? hL : hR);
			nodes.a.v[*anode].hight = *phi;
		} else if( bc1 <= -2 ) {       //ɌX
			if( (bc2 = judgeBalance(t->left)) >= 1 ) {  //EɌXĂ
				rotateLeft(&t->left, &hL );
			} else CHKB(-1, bc2, 0);
			rotateRight(anode, phi );
			//bc1 = judgeBalance(*anode); CHKB(-1, bc1, 1);
		} else if( bc1 >= 2 ) {                          //EɌX
			if( (bc2 = judgeBalance(t->right)) <= -1 ) { //ɌXĂ
				rotateRight(&t->right, &hR );
			} else CHKB(0, bc2, 1);
			rotateLeft(anode, phi );  //*s(=anode)̒lς
			//bc1 = judgeBalance(*anode); CHKB(-1, bc1, 1);
		} else  CHKA(0, 0, -1);
	}
	return 0;
}
/*  ID_PSTree::insert	oyam[h̍/Eɒǉ
***************************************************************************/
int PSTree::insert( //oyam[h̎qm[hԍԂB0:[hő݂Ȃ -1:G[
				    //qm[h͍̍XVݒ肷
	int oya,        //i  ŏʂ͐e(Empty)Ōďo node[]or-1
	int lrflg,      //i  -1: 1:E 0:oyaEmpty
	int np,         //i  pair[]
	bool useAsP,    //i  T:npq[vɓꂽ(rootm[hł.T.ŌĂ) F:npq[v̑Rׂꏊɓꂽ
	int *phi,       // o ǉ̎qm[h̍
	int findmode)   //i  [h 0:ǉ 1:ǉ
{
	BPSTnode	*t;
	int		anode, cnode, rc, hL, hR, *s, nextoya, npy;
	                                         CHKA(0, oya, nodes.a.size());
	if( isEmpty(oya) ) { anode = root; CHKB(0, lrflg, 0);}  //anode:oyam[h̎qB}m[h
	else if( lrflg < 0 ) anode = nodes.a.v[oya].left;
	else if( lrflg > 0 ) anode = nodes.a.v[oya].right;
	                                         CHKA(0, anode, nodes.a.size());
	if( isEmpty(anode) ) {
		if( findmode ) {  //݂ȂBO(Empty)Ԃ
		} else {
			BPSTnode	wkNode;
			wkNode.oya = oya;
			wkNode.q = np;
			wkNode.validP = false;
#define NTmethod1
#if ! defined(NTmethod1)
			wkNode.duplQ = ! useAsP;
#endif //defined(NTmethod1)
			wkNode.hight = 1;
			*phi = 1;
			if( (anode = node_add(wkNode)) < 0 ) { rc = -1; goto                  quit; }
			if( isEmpty(oya) )   root            = anode ;
			else if( lrflg < 0 ) nodes.a.v[oya].left  = anode ;
			else if( lrflg > 0 ) nodes.a.v[oya].right = anode ;
#if defined(NTmethod1)
			//q[v̓VT
			cnode = anode;
			npy   = pairs.a.v[np].y;
			for( nextoya = oya; ! isEmpty(nextoya); nextoya = t->oya ) {
				t = &nodes.a.v[nextoya];
				if( t->validP && compHeap(pairs.a.v[t->p].y, npy) <= 0 ) break;
				cnode = nextoya;
			}
			if( cnode == anode ) {
				nodes.a.v[anode].duplQ = 0;
			} else {
				BPSTnode	*c = &nodes.a.v[cnode];
				if( c->validP )
					disposeP(cnode);
				c->p = np;
				c->validP = true;
				nodes.a.v[anode].duplQ = 1;
			}
#endif //defined(NTmethod1)
			//t->balance = leafBalance;
		}
	} else {
		t = &nodes.a.v[anode];
#if ! defined(NTmethod1)
		if( useAsP ) {
			if( ! t->validP || compHeap(pairs.a.v[np].y, pairs.a.v[t->p].y) < 0 ) { //𖞂̂Ńq[vɓ
				disposeP(anode);
				t->p = np;
				t->validP = true;
				useAsP = false;
			}
		}
#endif //defined(NTmethod1)
		int lrf = compX(&pairs.a.v[np], &pairs.a.v[t->q]);
		if( lrf < 0 ) {  //T؂ւ̑}͖[܂łǂ
			hR = nodes.a.v[t->right].hight;
			if( (rc = insert(anode, -1, np, useAsP, &hL, findmode)) < 0 ) goto quit;  // qɑ}
		} else if( lrf > 0 ) {
			hL = nodes.a.v[t->left].hight;
			if( (rc = insert(anode,  1, np, useAsP, &hR, findmode)) < 0 ) goto quit;  // Eqɑ}
		} else if( ! findmode )                 CHKA(1, lrf, -1);
		if( lrf == 0 ) {  //ȂǉA̒lԂB
		} else if( ! findmode ) {
			//insert͎͂gȂBrealloc()Ȃ̂ŁB
			t = &nodes.a.v[anode];
			if( isEmpty(oya) ) { s = &root;  CHKB(0, lrflg, 0);}  //anode:oyam[h̎qB}m[h
			else if( lrflg < 0 ) s = &nodes.a.v[oya].left;
			else if( lrflg > 0 ) s = &nodes.a.v[oya].right;
			//adjustBalanceForInsert(t);
			adjustBalance( s, phi );
		}
	}
	rc = anode;
quit:
	return rc;
}

/*+++++++++++++++++++++++++++++++++++ delete ==> +++++++++++++++++++++++++++++++++++++++*/
/*  ID_PSTree::extractMaxQX	̉E}ǂő̂.̏epɕԂB
***************************************************************************/
int PSTree::extractMaxQX( //̉E}ǂŉẼm[hԍԂ
	int *anode,           // io ŉẼm[h̍}Ԃ
	ExtractedPair *ep,    //  o
	int *pd )             //  o ŉẼm[hԍԂ
{
	BPSTnode	&t = nodes.a.v[*anode];
	int		d, hL, hR;
	if( isEmpty(t.right) ) { //ő̃m[h폜
		ep->q = t.q;
		ep->duplAsP = t.duplQ;
		d = *anode;
		disposeP( d );
		*anode= t.left;
		if( ! isEmpty(t.left) ) nodes.a.v[t.left].oya = t.oya;
		//node_del( d );
	} else {
		extractMaxQX( &t.right, ep, &d );
		hL = nodes.a.v[t.left].hight;
		hR = nodes.a.v[t.right].hight;
		nodes.a.v[*anode].hight = 1 + ((hL > hR) ? hL : hR);
		if( ep->duplAsP && t.validP && t.p == ep->q ) {
			//폜ő̃yAɎm[ĥɂ
			ep->duplAsP = false;
			extractP( *anode );
		}
		//adjustBalanceForNeiborExtract(t);
		adjustBalance( anode, &hL );
	}
	*pd = d;
	return 0;
}
/*  ID_PSTree::deletion	m[h폜
***************************************************************************/
int PSTree::deletion( // 0:o^ 1:폜
	int *anode,       // io ŏʂ&rootŌďoBEmpty̏ꍇ
	BPSTpair &op,     // i  폜Ώۂ̃yA
	int *phi,         // o  폜*anode̍
	int dmy)
{
	                                       CHKA(0, *anode, nodes.a.size());
	BPSTnode	&t = nodes.a.v[*anode];
	ExtractedPair	n;
	int		d, x, delf = 0, hL, hR;
	                                       CHKA(0, t.q, pairs.a.size());
	if( ! isEmpty(*anode) ) {
		if( pairs.a.v[t.q] == op ) {
			delf = 1;
			disposeP( *anode );
			pair_del( t.q );
			d = *anode;
			if( isEmpty(t.left) || isEmpty(t.right) ) {
				if     ( ! isEmpty(t.left ) ) *anode = t.left;
				else if( ! isEmpty(t.right) ) *anode = t.right;
				else                          *anode = Empty;
				*phi = nodes.a.v[*anode].hight;
				if( ! isEmpty(*anode) ) {
					nodes.a.v[*anode].oya = nodes.a.v[d].oya; CHKA(1, *anode, nodes.a.size());
				}
				node_del( d );
			} else {  //qAEqƂɑ݂
				extractMaxQX( &t.left, &n, &x ); CHKA(1, x, nodes.a.size());
				//adjustBalance( anode, phi );
				hL = nodes.a.v[t.left].hight;
				hR = nodes.a.v[t.right].hight;
				*phi = 1 + ((hL > hR) ? hL : hR);  //CHKB(hi, *phi, hi);
				t.hight = *phi;
				t.q = n.q;
				t.duplQ = n.duplAsP;
#if 0 //m[ĥĂꍇA
				d = x;
#else //m[hnodes.a.v[*anode]̂ĂꍇA
				d = *anode;
				*anode = x;
				nodes.a.v[x] = t;           CHKA(0, t.left , nodes.a.size()); //폜t.left=0ɂȂ蓾
				if( ! isEmpty(t.left) ) nodes.a.v[t.left ].oya = x;
				nodes.a.v[t.right].oya = x; CHKA(1, t.right, nodes.a.size());
#endif
				extractP( *anode );
				node_del( d );
			}
		} else {
			if( compX(&op, &pairs.a.v[t.q]) < 0 ) {
				hR = nodes.a.v[t.right].hight;
				delf = deletion( &t.left , op, &hL, 0 );
			} else {
				hL = nodes.a.v[t.left ].hight;
				delf = deletion( &t.right, op, &hR, 0 );
			}
			if( delf ) {
				if( t.validP && pairs.a.v[t.p] == op ) extractP( *anode );
				//*phi = 1 + ((hL > hR) ? hL : hR);
				//nodes.a.v[*anode].hight = *phi;
			} else {
				*phi = nodes.a.v[*anode].hight;
			}
		}
		//adjustBalanceForDelete(t);
		adjustBalance( anode, phi );
	}
	return delf;
}
/*+++++++++++++++++++++++++++++++++++ delete <= +++++++++++++++++++++++++++++++++++++++*/
/*  ID_PSTree::build_sub	
***************************************************************************/
int PSTree::build_sub(int *list, int s, int e)  //0:list[s,e] >0:؂̍node[]Y <0:G[
{
#if 0
	int rc = 0, i, d, hi;

	for( i = s; i <= e; ++i ) {
		d = list[i];                               CHKA(0, d, this->pairs.a.size());
		if( this->pair[d].emptyNext >= 0 ) continue; //gpȂ
		rc = insert(Empty, 0, d, true, &hi, 0);
	}
	return root;
#else
	int rc = 0, i, a;
	BPSTnode r;

	if( s > e ) goto                         quit;   // 0 ԂďIB
	i = ( s + e ) / 2; a = list[i];  //:pair[]YBpair[]͍q؂̂ő̃m[hƂȂ
	/* ԃm[hpair[] */
	r.q = a; r.p = 0;		//.A.͋ 
	r.left  = build_sub(list, s, i-1);
	r.right = build_sub(list, i+1, e);
	r.hight = ( (nodes.a.v[r.left].hight)>(nodes.a.v[r.right].hight) ) ? (nodes.a.v[r.left].hight):(nodes.a.v[r.right].hight);  //.left,rightvZ
	r.hight++;
	rc = node_add( r );
	if( ! isEmpty(r.left ) ) nodes.a.v[r.left].oya = rc;
	if( ! isEmpty(r.right) ) nodes.a.v[r.right].oya = rc;
	//q[v.̋𖄂߂B
	extractP( rc ); //ōň̏ꍇlogN̎Ԃ
quit:
	return rc;
#endif
}
/*  ID_PSTree::build_sorted	
***************************************************************************/
int PSTree::build_sorted( //0: <0:G[ >0:f[^G[
	int nList,   //i
	int *list)   //i pair[]ỸXg
{
	int rc, k, apair, bpair;
	/*	pair[]thisclear()BheapType,pair[],n_pair̓NAȂ */
	clear1();
	//`FbN̂
	if(dbgf[8]) {
		for( k = 1; k < nList; ++k ) {
			apair = list[k-1];
			bpair = list[k];
			rc = compX( &pairs.a.v[apair], &pairs.a.v[bpair]); CHKB(rc, -1, -1);
		}
	}
	if(dbgf[9]>1) {
		Dprintf("nList(%d)\n", nList);
		Dprintf("no     n     x     y\n");
		for( k = 0; k < nList; ++k )
			Dprintf("%2d%6d%6d%6d\n",list[k], this->pairs.a.v[list[k]].n, this->pairs.a.v[list[k]].x, this->pairs.a.v[list[k]].y );
	}
	root = build_sub(list, 0, nList - 1);
	if( nList > 0 ) {CHKA(1, root, nodes.a.size());} else {CHKB(0, root, 0)}
												//	CHKB(nodes.a.size()-1, nodes.num, nodes.a.size()-1);
	//oya(root)nil
	nodes.a.v[root].oya = 0;
	rc = 0;
	if(dbgf[8]) check0();
	if(dbgf[9]) dump_node(-1, -1);
//quit:
	return rc;
}
/*  ID_PSTree::build	
***************************************************************************/
int PSTree::build(        //0: <0:G[ >0:f[^G[
	VECTOR<int>& pList)   //i  pair[]̈ꗗB    //w pairꗗ̍쐬p
{
	int rc = 0, k, cnt;

//	/* Lpair[]̓YXg */
//	pList.clear();
//#if 1
//int atode_henkou;
//	for( k = topPair; k > 0; k = - pairs.a[k].emptyNext - 1 ) {
//		if( (rc = pList.push_back(k)) < 0 ) goto                     quit;
//	}
//#else
//	for( k = 1; k < this->pairs.a.size(); ++k ) {
//		if( pairs.a.v[k].emptyNext >= 0 ) continue;
//		if( (rc = pList.push_back(k)) < 0 ) goto                     quit;
//	}
//#endif
	/* WŃ\[g */
	if( (cnt = pList.size()) <= 0 ) pList.push_back(0); //pList[0]QƏo悤Ƀ_~[ǉĂ
	xqsort(&pList[0], cnt, *this, &PSTree::compIdx);
	rc = build_sorted(cnt, &pList[0]);
quit:
	return rc;
}
/*  ID_PSTree::getQList	̏pair[]ỸXgL1Bclear()͌Ăԑ
***************************************************************************/
int PSTree::getQList(sscvect<int> *L1, int anode)  //rc=0:\[gsv >0:Kv <0:s
{
	int rc = 0;
	/*̏pair[]ỸXgL1Bclear()͌Ăԑ */
	if( anode > 0 ) {                            //NT110823add
		if( (rc = getQList(L1, nodes.a.v[anode].left)) < 0 ) goto                     quit;
		if( (rc = L1->push_back(nodes.a.v[anode].q)) < 0 ) goto                     quit;
		if( (rc = getQList(L1, nodes.a.v[anode].right)) < 0 ) goto                    quit;
	}
	if(dbgf[8]) {
		int rtc, i;
		//compX  check
		for( rc = 0,i = 1; i < L1->size(); ++i ) {
			rtc = compX( &pairs.a.v[(*L1)[i-1]], &pairs.a.v[L1->v[i]] ); CHKA(rtc, rtc, 0);
			if( rtc > 0 ) ++rc;
		}
	}
	rc = 0;
quit:
	return rc;
}
/*  ID_PSTree::getNList	̏pair[].ñXgpIdxList[]B
***************************************************************************/
int PSTree::getNList(
//	int *pIdxList,    //o pair[].ñXg
//	int x_pIdxL,      //i
//	int *n_pIdxL)     //o
	VECTOR<int> *pIdxList) //o
{
	int i, apair;
	pIdxList->clear();
	this->getQList(pIdxList, root);
	for( i = 0; i < pIdxList->size(); ++i ) {
		apair = (*pIdxList)[i];
		(*pIdxList)[i] = this->pairs.a.v[apair].n;
	}
	return 0;
}

/*  ID_PSTree::intersect	Q̂ors(T1,T2)̋ʏWpairP̂orsB
***************************************************************************/
int PSTree::intersect(   //I敪SegPSTreeŉ]̐W̏CɎgB
	PSTree &T1, PSTree &T2, //i
	VECTOR<int> &t1List, VECTOR<int> &t2List, VECTOR<int> &pList)
{
	int rc = 0, i, k, apair, size1, size2, cnt;

	this->clear();
	pList.clear();
	//̏T1.pair[]ỸXgL1B
	t1List.clear(); T1.getQList(&t1List, T1.root); size1 = t1List.size(); CHKB(T1.n_pair, size1, T1.n_pair);
	//̏T2.pair[]ỸXgL2B
	t2List.clear(); T2.getQList(&t2List, T2.root); size2 = t2List.size(); CHKB(T2.n_pair, size2, T2.n_pair);
	//	L1,L2pair̋ʕthis->pair[]ɒǉB
	i = k = 0;
	while( i < size1 && k < size2 ) {
		rc = compX( &T1.pairs.a.v[t1List[i]], &T2.pairs.a.v[t2List[k]] );
		if       ( rc < 0 ) { ++i;
		} else if( rc > 0 ) { ++k;
		} else {
//			if( (apair = rc = this->pair_add(T1.pairs.a.v[t1List[i]])) < 0 ) goto quit;
			BPSTpair wkPair = T1.pairs.a.v[t1List[i]];
			if( (apair = rc = this->pair_add(wkPair)) < 0 ) goto quit;
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++i; ++k;
		}
	}
	//PSTreeꊇ쐬BPSTree::build()
	if( (cnt = pList.size()) <= 0 ) pList.push_back(0); //pList[0]QƏo悤Ƀ_~[ǉĂ
	rc = build_sorted(cnt, &pList[0]);
quit:
	return rc;
}
/*  ID_PSTree::plus	ors(this,T2)̘aWpairors(this)B
***************************************************************************/
int PSTree::plus(   //I敪SegPSTreeŉ]̐W̏CɎgB
	PSTree &T2, //i
	VECTOR<int> &t1List, VECTOR<int> &t2List, VECTOR<int> &pList)
{
	int rc = 0, i, k, apair, size1, size2, cnt;
	PSTree &T1 = *this;

	pList.clear();
	//̏T1.pair[]ỸXgL1B
	t1List.clear(); T1.getQList(&t1List, T1.root); size1 = t1List.size(); CHKB(T1.n_pair, size1, T1.n_pair);
	//̏T2.pair[]ỸXgL2B
	t2List.clear(); T2.getQList(&t2List, T2.root); size2 = t2List.size(); CHKB(T2.n_pair, size2, T2.n_pair);
	//	L1,L2pair}[WȂthis->pair[]ɒǉB
	i = k = 0;
	while( i < size1 || k < size2 ) {
		if     ( i >= size1 ) rc = 1;
		else if( k >= size2 ) rc = -1;
		else rc = compX( &T1.pairs.a.v[t1List[i]], &T2.pairs.a.v[t2List[k]] );
		if( rc < 0 ) {
			apair = t1List[i];
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++i;
		} else if( rc > 0 ) {
//			if( (apair = rc = this->pair_add(T2.pairs.a.v[t2List[k]])) < 0 ) goto quit;
			BPSTpair wkPair = T2.pairs.a.v[t2List[k]];
			if( (apair = rc = this->pair_add(wkPair)) < 0 ) goto         quit;
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++k;
		} else {                        CHKA(0,0,-571);  //敪؂̉]ł͗L蓾Ȃ̂CHKG[
			apair = t1List[i];
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++i;  ++k;
		}
	}
	//PSTreeꊇ쐬BPSTree::build()
	if( (cnt = pList.size()) <= 0 ) pList.push_back(0); //pList[0]QƏo悤Ƀ_~[ǉĂ
	rc = build_sorted(cnt, &pList[0]);
quit:
	return rc;
}
/*  ID_PSTree::minus	ors(this,T2)̍Wpairors(this)B
***************************************************************************/
int PSTree::minus(   //I敪SegPSTreeŉ]̐W̏CɎgB
	PSTree &T2, //i
	VECTOR<int> &t1List, VECTOR<int> &t2List, VECTOR<int> &pList)
{
	int rc = 0, i, k, apair, size1, size2, cnt;
	PSTree &T1 = *this;

	pList.clear();
	//̏T1.pair[]ỸXgL1B
	t1List.clear(); T1.getQList(&t1List, T1.root); size1 = t1List.size(); CHKB(T1.n_pair, size1, T1.n_pair);
	//̏T2.pair[]ỸXgL2B
	t2List.clear(); T2.getQList(&t2List, T2.root); size2 = t2List.size(); CHKB(T2.n_pair, size2, T2.n_pair);
	//	L1,L2pair}[WȂthis->pair[]ɒǉB
	i = k = 0;
	while( i < size1 ) {
		if( k >= size2 ) rc = -1;
		else rc = compX( &T1.pairs.a.v[t1List[i]], &T2.pairs.a.v[t2List[k]] );
		if( rc < 0 ) {
			apair = t1List[i];
			if( (rc = pList.push_back(apair)) < 0 ) goto                 quit;
			++i;
		} else if( rc > 0 ) {           CHKA(0,0,-571);  //敪؂̉]ł͗L蓾Ȃ̂CHKG[
			++k;
		} else {   //`|aZł͂`폜
			apair = t1List[i];
			pair_del( apair );
			++i;  ++k;
		}
	}
	//PSTreeꊇ쐬BPSTree::build()
	if( (cnt = pList.size()) <= 0 ) pList.push_back(0); //pList[0]QƏo悤Ƀ_~[ǉĂ
	rc = build_sorted(cnt, &pList[0]);
quit:
	return rc;
}
/*  ID_PSTree::dump_node	
***************************************************************************/
void PSTree::dump_node(int s, int e)
{
	if( s < 0 ) s = 0;
	if( e < 0 ) e = nodes.a.size() - 1;
	Dprintf("root = %d topEmptyNode = %d\n", root, nodes.getTopEmpty() );
	for( ; s <= e; ++s ) {
		BPSTnode &t = nodes.a.v[s];
		BPSTpair &p = pairs.a.v[t.p];
		printf("nodes.a.v[%2d] vP(%2d) p(%2d %2d %2d) q(%2d %2d %2d) duplQ(%2d) oy(%2d) L(%2d) R(%2d) h(%2d)\n"
			, s, t.validP, p.n, p.x, p.y, pairs.a.v[t.q].n, pairs.a.v[t.q].x, pairs.a.v[t.q].y
			, t.duplQ, t.oya, t.left, t.right, t.hight );
	} fflush(stdout);
}
/************************** TEST MAIN *************************************/
/*  ID_PSTree::check1	Nƃq[vlATl`FbN
***************************************************************************/
int PSTree::check1(
	int oya,         //e
	int v,           // node[]
	BPSTpair &low,   //[A)
	BPSTpair &upp)
{
	int left, right, rc, nsu, hL, hR, hi, op;
	BPSTnode	*t = &nodes.a.v[v];

	nsu = hL = hR = 0;
	rc = compX(&low, &upp);     CHKB(rc, rc, 0); //CHKB(-1, rc, -1);
	if( isEmpty(v) ) return 0;
	BPSTpair &qpair = pairs.a.v[t->q];            //Tl`FbN
	rc = compX(&low, &qpair);     CHKB(rc, rc, 0);
	rc = compX(&qpair, &upp);     CHKB(rc, rc, -1);
	nsu = 1;                   //m[h
	//heap condition
	op = nodes.a.v[oya].p;
	if( isEmpty(oya) ) {     //oyat->duplQ=F̂͂
		rc = t->duplQ;                         CHKB(0, rc, 0); 
	} else if( ! nodes.a.v[oya].validP ) { //oya.validP=FȂ
		rc = t->duplQ;                         CHKB(1, rc, 1); //q͑ĉɂ͂
		                                       if(t->validP) CHKA(0, rc, -571); //qv.validP=F
	} else if( ! t->validP ) { //oya.validP=Tq.validP=FȂ
		if( ! t->duplQ ) {
			rc = compHeap( pairs.a.v[op].y , pairs.a.v[t->q].y ); CHKB(rc, rc, 0); //:D :ED
		}
	} else {
		rc = compHeap( pairs.a.v[op].y , pairs.a.v[t->p].y ); CHKB(rc, rc, 0); //:D :ED
	}
	if( ! t->duplQ && ! isEmpty(oya)) {  //NT071218add
		rc = nodes.a.v[oya].validP;  CHKB(1, rc, 1); //t->duplQ=FȂ΁Ae.p݂͑͂
		rc = compHeap( pairs.a.v[op].y , pairs.a.v[t->q].y ); CHKB(rc, rc, 0); //:D :ED
	}
	//qƍ̃N`FbN
	left = t->left;
	if( ! isEmpty(left) ) {                    CHKA(1, left, nodes.a.size());
		hL = nodes.a.v[left].hight;               CHKB(v, nodes.a.v[left].oya, v);
	}
	//Eqƍ̃N`FbN
	right = t->right;
	if( ! isEmpty(right) ) {                   CHKA(1, right, nodes.a.size());
		hR = nodes.a.v[right].hight;              CHKB(v, nodes.a.v[right].oya, v);
	}
	//oX̃`FbN
	if( unbalance == 0 ) { hi = judgeBalance(v);  CHKB(-1, hi, 1); }
	hi = 1 + ((hL > hR) ? hL : hR);            CHKB(hi, t->hight, hi); //`FbN
	nsu += check1( v, left , low, qpair);
	nsu += check1( v, right, qpair, upp);
	return nsu;
}
/*  ID_PSTree::check2_1	duplQ`FbN(1) validP[NɎgBduplQ=T̃m[hcɋ邩
***************************************************************************/
int PSTree::check2_1( int v, VECTOR<int>& vintwk)
{
	int oya, nsu = 0;
	BPSTnode	*s, *t = &nodes.a.v[v];

	if( isEmpty(v) ) return 0;
	vintwk[v] = (t->validP) ? 1 : 0;
	for( oya = t->oya; ! isEmpty(oya); oya = s->oya ) {
		s = &nodes.a.v[oya];
		if( s->validP && pairs.a.v[t->q] == pairs.a.v[s->p] ) {
			++nsu;
			if( t->duplQ ) {            CHKB(1, vintwk[oya], 1); //CHKB(1, s->validP, 1);
				++vintwk[oya]; //++s->validP;
			} else CHKB(0, nsu, 0);
		}
	}
	if( t->duplQ ) { CHKB(1, nsu, 1);
	} else           CHKB(0, nsu, 0);
	check2_1( t->left , vintwk);
	check2_1( t->right, vintwk);
	return nsu;
}
/*  ID_PSTree::check2_2	duplQ`FbN(2) validP߂(n)
***************************************************************************/
int PSTree::check2_2( int v, VECTOR<int>& vintwk)
{
	BPSTnode	*t = &nodes.a.v[v];
	if( isEmpty(v) ) return 0;
	if( t->validP ) {  CHKB(2, vintwk[v], 2); //CHKB(2, t->validP, 2);
		//t->validP = 1;
	}
	check2_2( t->left , vintwk);
	check2_2( t->right, vintwk);
	return 0;
}
/*  ID_PSTree::check0	
***************************************************************************/
void PSTree::check0()
{
	static VECTOR<int> vintwk;
	int		rc, duplQ, validP;
	BPSTnode	&t = nodes.a.v[0];
//	BPSTpair low(-1, -1, 0), upp(imax, imax, 0);
	BPSTpair low(INT_MIN, INT_MIN, 0), upp(INT_MAX, INT_MAX, 0);
	duplQ = t.duplQ; validP = t.validP;
	CHKB(0, t.oya, 0); CHKB(0, t.left, 0); CHKB(0, t.right, 0); CHKB(0, t.p, 0); CHKB(0, t.q, 0);
	 CHKB(0, validP, 0); CHKB(0, duplQ, 0); CHKB(0, t.hight, 0);
	if( root == 0 || n_pair == 0 || n_node == 0 ) { CHKB(0, root, 0);
		CHKB(0, n_pair, 0);
		CHKB(0, n_node, 0);
	}
	vintwk.clear();
	rc = getQList(&vintwk, root); CHKB(n_pair, vintwk.size(), n_pair); CHKB(n_node, vintwk.size(), n_node);
	rc = check1(0, root, low, upp); CHKB(rc, n_node, rc);
	vintwk.resize(nodes.a.size());
	check2_1(root, vintwk);
	check2_2(root, vintwk);
}
