/*
 * FILE     : pstree1.cpp
 * Copyright (C) 2007 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : q[vT(place holder)
 * AUTHER   : N.Tsuchiya  2007.11.25
 */
/*
	q[vT(balanced priority search trees)
	l̕tT؁Al̃q[v
	http://www.cs.brown.edu/courses/cs252/misc/resources/lectures/pdf/notes18.pdf
	uPriority Search Trees - Part IIv Prof. Roberto Tamassia Sem. II, 1993{1994
	Lecture 10 Date: May 22, 1994 Scribe: Michael Shapiro
 */
static char	*__file =(char*)__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h> //http://www.jaist.ac.jp/~t-asano/dstruct/kousei.txt

#define EXTERN
#include "McCreight2.h" // McCreght (Place Holderŋp)
#include "pstree2_cc.h"

//#define PROFILE_CHOUSA
#if defined(PROFILE_CHOUSA)
int CHECK0(){return 0;}
#else
#  define CHECK0 pst.check0
#endif

//extern PSTree pst;

/*============================= test program =============================*/
#include <time.h>
//int chk_, chk_rc;

struct testdata {
	int x, y;
	int addf;
};
static struct testdata td[256];

/*  ID_check3	first() next()T`FbN
***************************************************************************/
int check3(int n_td, int x1, int x2, int y0, PSTree &pst)
{
//return 0;   //profilep
	int		cnt = 0, no, heapType;
	heapType = pst.getHheapType(); //0:傫D 1:D
	testdata *ptd;
//	if( n_td == 18 )
//		pst.dump_node( -1, -1);
	for( no = 0; no < n_td; ++no ) {
		ptd = &td[no];
		if( ptd->addf == 0 ) continue;
//		if( ptd->x >= x1 && ptd->x <= x2 && pst.compHeap(ptd->y, y0) <= 0 ) {
		if( ptd->x < x1 || ptd->x > x2 ) continue;
		if( ptd->y > y0 && heapType != 0 ) continue;
		if( ptd->y < y0 && heapType == 0 ) continue;
		++cnt;
	}
	int cnt2 = 0;
	if( (no = pst.first(x1, x2, y0)) >= 0 ) {
		ptd = &td[no];                        CHKB(x1, td[no].x, x2);
		++cnt2;
		if( heapType != 0 ) {                  CHKB(0, ptd->y, y0);
		} else {                              CHKB(0, y0, ptd->y);
		}
		while( (no = pst.next()) >= 0 ) {
			ptd = &td[no];                    CHKB(x1, ptd->x, x2);
			++cnt2;
			if( heapType != 0 ) {              CHKB(0, ptd->y, y0);
			} else {                          CHKB(0, y0, ptd->y);
			}
		}
	}   CHKB(cnt, cnt2, cnt);
	if( cnt != cnt2 ) Dprintf( "cnt(%d)cnt2(%d)x1(%d)x2(%d)y0(%d)\n", cnt, cnt2, x1, x2, y0), fflush(stdout);
	return cnt;
}
/*  ID_test2	
***************************************************************************/
int test2(int n_td, PSTree &pst)
{
	int 	rc, i, no, imax = 0x7fffffff, x1, x2, y0, cnt;
//	PSTree pst;
	int dbgf = 0;
	for( i = 0; i < n_td; ++i ) {
		td[i].x = rand() % 256;
		td[i].y = rand() % 256;
		td[i].addf = 0;
	}
#if 1
	cnt = pst.size();
	for( no= 0; no < n_td; ++no ) {
		if( dbgf ) Dprintf("no(%d)\n", no );
		if( dbgf ) Dprintf( "lseg_push(%3d, %3d, %3d)\n", no, td[no].x, td[no].y), fflush(stdout);
		pst.insert( no, td[no].x, td[no].y );  CHECK0();
		++cnt;
//Dprintf("insert  p(%2d %3d %3d) \n", no, td[no].x, td[no].y );
	}
//pst.dump_node( -1, -1);
	if( dbgf ) pst.dump_node(-1, -1);
	for( no= 0; no < n_td; ++no ) {
		if( dbgf ) Dprintf("no(%d)\n", no );
		if( dbgf ) Dprintf( "lseg_del(%3d, %3d, %3d)\n", no, td[no].x, td[no].y), fflush(stdout);
		if( n_td == 4 && no == 1 )
			pst.dump_node( -1, -1);
		rc = pst.deletion(no, td[no].x, td[no].y);  CHECK0(); CHKB(1, rc, 1);
		--cnt;
	}                                  CHKB(Empty, pst.root, Empty);
#endif
#if 1
	if( n_td > 0 ) {
		for( i = 0; i < 10000; ++i ) {
			if( dbgf ) Dprintf("i(%d)\n", i ), fflush(stdout);
			no = rand() % n_td;
			if( td[no].addf ) {
				if( dbgf ) Dprintf( "lseg_del (%3d, %3d, %3d)\n", no, td[no].x, td[no].y), fflush(stdout);
				rc = pst.deletion(no, td[no].x, td[no].y);  CHECK0(); CHKB(1, rc, 1);
			} else {
				if( dbgf ) Dprintf( "lseg_push(%3d, %3d, %3d)\n", no, td[no].x, td[no].y), fflush(stdout);
				pst.insert( no, td[no].x, td[no].y );  CHECK0();
			}
			td[no].addf = 1 - td[no].addf;
			//x1 y0 rand
			x1 = rand() % 256;
			x2 = rand() % 256;
			y0 = rand() % 256;
			if( x1 > x2 ) { int w = x1; x1 = x2; x2 = w; }
#if defined(PROFILE_CHOUSA)
	if( (no = pst.first(x1, x2, y0)) >= 0 ) { //Ԍvpɂ
		while( (no = pst.next()) >= 0 ) {
		}
	}
#else
			//first next cnt
			if( n_td == 1 && i == 2498 )
				rc = rc;
			check3(n_td, x1, x2, y0, pst);
#endif //defined(PROFILE_CHOUSA)
		}
	}
#endif
	if( dbgf ) pst.dump_node(-1, -1);

	return 0;
}

/*  ID_test3	
***************************************************************************/
int test3(int n_td, PSTree &pst)
{
	int 	i, no, x1, x2, y0;
//	PSTree pst;
	int dbgf = 1;

	x1 = 50; x2 = 200; y0 = 200;
	for( i = 0; i < n_td; ++i ) {
		td[i].x = rand() % 256;
		td[i].y = rand() % 256;
		if( td[i].x > td[i].y ) {no = td[i].x; td[i].x = td[i].y; td[i].y = no;}
		td[i].addf = 0;
	}
	for( no= 0; no < n_td; ++no ) {
		if( dbgf > 1 ) Dprintf("no(%d)\n", no );
		if( dbgf ) Dprintf( "lseg_push(%3d, %3d, %3d)\n", no, td[no].x, td[no].y), fflush(stdout);
		pst.insert( no, td[no].x, td[no].y );  CHECK0();
		td[no].addf = 1;
	}
	if( dbgf > 1 ) pst.dump_node(-1, -1);

	check3(n_td, x1, x2, y0, pst);
	return 0;
}
#if 0
int Eprintf(char *s, int ewMode) { return Dprintf("%s", s);}
/*  ID_chk_ab
***************************************************************************/
int chk_ab  (
	int t, long lx, long ly, long lz, char *file, int  line, char *sx, char *sy, char *sz)
{
	Dprintf("*** CHK%c error <== %8s(%d) %s(%ld) %s(%ld) %s(%ld)\n",
		t?'B':'A', file, line, sx, lx, sy, ly, sz, lz ) ; fflush(stdout);
	return(1);
}
#endif
/*  ID_testBpst	internetTvors쐬(q[vFAoX)
***************************************************************************/
int testBpst(PSTree &pst)
{
//	PSTree pst;
	int rc = pst.first(0, 100, 100);
#if 0 //for place holder version
	pst.insert( 1, 11, 21 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 3, 14,  7 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 6, 17, 30 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 9, 21,  8 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 8, 15,  2 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert(11, 33, 33 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 2,  3,  4 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 4,  2, 12 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 5,  4, 11 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 7,  8,  5 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert(10,  5,  3 ); CHECK0(); //pst.dump_node( -1, -1);
#else  //for McCreight version
	pst.insert( 1, 11, 21 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 2,  3,  4 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 3, 14,  7 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 4,  2, 12 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 5,  4, 11 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 6, 17, 30 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 7,  8,  5 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert(10,  5,  3 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 9, 21,  8 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert( 8, 15,  2 ); CHECK0(); //pst.dump_node( -1, -1);
	pst.insert(11, 33, 33 ); CHECK0(); //pst.dump_node( -1, -1);
#endif
//	pst.insert( 0, 1, 2 ); CHECK0();
//	pst.insert( 1, 3, 4 ); CHECK0();
	pst.dump_node( -1, -1);
	return 0;
}
/*  ID_testBpst	internetTvors쐬(q[vFAoX)
***************************************************************************/
int cctestBpst()
{
#if 1 //for place holder version
	cc_insert( 1, 11, 21 );
	cc_insert( 3, 14,  7 );
	cc_insert( 6, 17, 30 );
	cc_insert( 9, 21,  8 );
	cc_insert( 8, 15,  2 );
	cc_insert(11, 33, 33 );
	cc_insert( 2,  3,  4 );
	cc_insert( 4,  2, 12 );
	cc_insert( 5,  4, 11 );
	cc_insert( 7,  8,  5 );
	cc_insert(10,  5,  3 );
#else  //for McCreight version
	cc_insert( 1, 11, 21 );
	cc_insert( 2,  3,  4 );
	cc_insert( 3, 14,  7 );
	cc_insert( 4,  2, 12 );
	cc_insert( 5,  4, 11 );
	cc_insert( 6, 17, 30 );
	cc_insert( 7,  8,  5 );
	cc_insert(10,  5,  3 );
	cc_insert( 9, 21,  8 );
	cc_insert( 8, 15,  2 );
	cc_insert(11, 33, 33 );
#endif
extern PSTree pst;  //pstree1_cc.cppŐ錾Ăpst
	pst.dump_node( -1, -1);
	return 0;
}
/*  ID_main	
***************************************************************************/
int main( int argc, char **argv )
{
	int n_td;
	int rc;

	double cpu0, cpu1;
	double	dtm;
	PSTree pst, pst1, pst2, pst3;

	rc = cc_init();
	dbgf[50] = dbgf[51] = 2; dbgf[8] = 1;
#if 0
	int rc, pn, px, py, on, ox, oy, ok, edgeType, koType, vVal, hVal, lLim, rLim;
	cctestBpst();
	rc = cc_clear();
	cc_read("testnode.csv");
	//(tree`p)ߓ_Ԃ
	rc = cc_getNodeNum( &num );
	for( k = 0; k < num; ++k ) {
		//(tree`p)Ԗڂ̐ߓ_̏Ԃ
		rc = cc_getNodeInf( k, &pn, &px, &py, &on, &ox, &oy, &ok, &edgeType, &koType, &vVal, &hVal, &lLim, &rLim);
	}
//	cc_write("testnode.csv");
	rc = cc_clear();
//return 0;
#endif
#if 1
//	testBpst(pst);

	n_td = 4;
	n_td = 1;
	cpu0 = clock();
	for( ; n_td <= 256; ++n_td ) {
		pst.clear();
//		test3(n_td, pst);
		test2(n_td, pst);
		cpu1 = clock();
		dtm = (cpu1 - cpu0) / CLOCKS_PER_SEC;
		Dprintf( "n_td = %d", n_td );
		Dprintf( " cpu(%.3f) (%.3f) (%.3f)\n", cpu1 / CLOCKS_PER_SEC, dtm,  dtm/n_td * 1000), fflush(stdout);
		cpu0 = cpu1;
	}
#endif

	test3(5, pst1);
	test3(7, pst2);
	//	PSTreeꊇ쐬B
//	rc = pst1.build();
//	rc = pst2.build();
//	pst.mearge(pst1, pst2, &pst3);
//	rc = pst.build();
	return 0;
}
