/*
 * FILE     : pstree2.h
 * Copyright (C) 2007 Sogen System Co., Ltd
 * SYSTEM   : np[c
 * FUNCTION : q[vT(place holder)
 * AUTHER   : N.Tsuchiya  2007.11.25
 */
/*
	q[vT(balanced priority search trees)
	l̕tT؁Al̃q[v
	http://www.cs.brown.edu/courses/cs252/misc/resources/lectures/pdf/notes18.pdf
	uPriority Search Trees - Part IIv Prof. Roberto Tamassia Sem. II, 1993{1994
	Lecture 10 Date: May 22, 1994 Scribe: Michael Shapiro
 */
#if ! defined(PSTREE2_H)
#define PSTREE2_H

#include "ssc.h"
#include "sscvect.h"
#define Empty  0
struct ExtractedPair {
	int 	q;
	bool	duplAsP;
} ;
struct BPSTpair {
	int		n;           //ߓ_ԍ([Uw)
	int		x;           //T؂\
	int		y;           //q[v\
	int		next;        //󃊃NB擪topEmptyPair
//	bool operator==(const BPSTpair &p) { return x == p.x && y == p.y; }
	bool operator==(const BPSTpair &p) { return n == p.n ; }
	BPSTpair():n(-1),x(0),y(0),next(0){}                 //ftHgRXgN^
	BPSTpair(int pn,int px,int py):n(pn),x(px),y(py),next(0){}  //RXgN^
	BPSTpair& operator=(const BPSTpair &p) { n = p.n; x = p.x; y = p.y; return *this; }
} ;
struct BPSTnode {
	int 	p;       //q[v\B(leaf node)̏ꍇ     pair[]
	int 	q;       //T؂\                                     pair[]
	int		oya, left, right;                                        //    node[]
    int    balance;           // oXx L: ɌXĂB R: EɌXĂBE: EB
    int    hight;             // ؂̍B[̍PDmFpA߂
	BPSTnode():p(Empty),q(Empty),left(Empty),right(Empty),oya(Empty),hight(0){}  //RXgN^
	BPSTnode& operator=(const BPSTnode &pp) { p = pp.p; q = pp.q; 
		oya = pp.oya; left = pp.left; right = pp.right; hight = pp.hight; return *this; }
} ;
struct PSTree {
	sscvect<BPSTnode> node;
	sscvect<BPSTpair> pair;
	int		root;
	int		n_node;
	int		n_pair;
	int		topEmptyNode;
	int		topEmptyPair;
	//first() next()Tp
	int		last_node;    //ŌɕԂm[hԍB-1:TI            node[]or-1
	int x1, x2, y0;
	PSTree(){root = topEmptyNode = topEmptyPair = Empty; n_node = n_pair = 0;  //RXgN^
		node.push_back(BPSTnode()); pair.push_back(BPSTpair()); }
	int insert(int pn,int px,int py){int hi; return insert(Empty, 0, pair_add(BPSTpair(pn, px, py)),true, &hi);}
	int deletion(int pn,int px,int py){int hi; return deletion(&root, BPSTpair(pn, px, py), &hi, 0);}
	void dump_node(int s, int e);
	int first(int x1, int x2, int y0);
	int next();
	int compHeap(int p, int q){  //ۓTL[̔rB:(p)D :E(q)D
		return q - p;  //傫D
//		return p - q;  //D
	}
	//`FbNp
	void check0();
private:
	int isLeaf( int anode );
	int disposeP( int anode );
	int extractP( int anode );
	int rotateRight(int *anode, int *phi );
	int rotateLeft (int *anode, int *phi );
	int adjustBalance(int *anode, int *phi);
	int insert(int oya, int lrflg, int np,bool useAsP, int *phi);
	int extractMaxQX(int *anode,ExtractedPair *ep, int *pd );
	int deletion( int *anode, BPSTpair &op, int *phi, int qnode );
	int pair_add(BPSTpair &wkPair);
	int pair_del( int d );
	int node_add(BPSTnode &wkNode);
	int node_del( int d );
	int compX( BPSTpair *p, BPSTpair *q );
	int judgeBalance(int anode);
	int findBelow( int rt );
	//`FbNp
	int check1(int oya, int v, BPSTpair &low, BPSTpair &upp);
	int check2_1( int v);
	int check2_2( int v);
} ;
#endif //! defined(PSTREE2_H)
